﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private frm As Form
	Private btnExtractVariables As Button
	Private txtSource As TextArea
	Private txtTarget As TextArea
	Private strSource As String
	Private strTarget As String
	Private imgViews As List
End Sub


Sub Close
	frm.close
End Sub

Public Sub Show
	'jMash.HidePrevious
	'Main.kvs.PutSimple("lastform", "frmNewButton") 
	frm.Initialize("frm", 600, 600)
	frm.RootPane.LoadLayout("extractvariables")
	txtSource.text=""
	txtTarget.text=""
	frm.Resizable = False
	frm.Title = "jMashBal2Bil > Source Code Convertor"
	frm.BackColor = fx.Colors.White
	jMash.Form_SetBackgroundImage(frm,"Elegant_Background-2.jpg")
	jMash.Form_SetIcon(frm,"convert.png")
	'frm.SetOwner(Main)
	frm.Show
	jMash.Form_CenterOnScreen(frm) 
End Sub

Sub btnExtractVariables_Action
	strSource = txtSource.text
	strSource = strSource.trim
	If strSource.Length = 0 Then
		jMash.Error("Source Code Error", "There is no source code that has been provided to process. Please copy and paste your source code above.")
		Return
	End If
	' process the lines
	Dim spLines() As String
	Dim spTot As Int
	Dim spCnt As Int
	Dim sFind As String
	Dim sReplace As String
	Dim sLine As String
	' start processing
	jMash.InitVariables
	imgViews.Initialize 
	' process replacers
	spTot = jMash.replacers.Size - 1
	For spCnt = 0 To spTot
		sFind = jMash.replacers.GetKeyAt(spCnt)
		sReplace = jMash.replacers.GetValueAt(spCnt)
		strSource = strSource.Replace(sFind,sReplace)  
	Next
	'process comment out
	Dim cTot As Int
	Dim cCnt As Int
	Dim cStr1 As String
	
	cTot = jMash.commentout.Size - 1 
	spLines = jMash.StrParse(CRLF,strSource)
	spTot = spLines.Length - 1
	' for each line in the code
	For spCnt = 0 To spTot
		sLine = spLines(spCnt)
		sLine = sLine.Trim
		sLine = sLine.ToLowerCase 
		For cCnt = 0 To cTot
			cStr1 = jMash.commentout.Get(cCnt)
			cStr1 = cStr1.ToLowerCase 
			If sLine.StartsWith(cStr1) = True Then
				sLine = "'" & sLine
				spLines(spCnt) = sLine 
			End If
		Next
		' fix startactivity
		spLines(spCnt) = FixStartActivity(spLines(spCnt))
		' does this line have imageviews
		cStr1 = spLines(spCnt)
		cStr1 = cStr1.ToLowerCase
		If jMash.endswith(cStr1, "as imageview") = True Then
			cStr1 = spLines(spCnt)
			cStr1 = cStr1.trim
			cStr1 = jMash.mvfield(spLines(spCnt),2," ")
			cStr1 = cStr1.trim
			imgViews.Add(cStr1) 
		End If
		' does this line have panels
		cStr1 = spLines(spCnt)
		cStr1 = cStr1.ToLowerCase
		If jMash.endswith(cStr1, "as panel") = True Then
			cStr1 = spLines(spCnt)
			cStr1 = cStr1.trim
			cStr1 = jMash.mvfield(spLines(spCnt),2," ")
			cStr1 = cStr1.trim
			imgViews.Add(cStr1) 
		End If
	Next
	' consolidate the code
	strSource = jMash.MvFromArray(spLines,CRLF)
	' now process image enablement / disablement
	cTot = imgViews.Size -1 
	For cCnt = 0 To cTot
		cStr1 = imgViews.Get(cCnt)
		sFind = cStr1 & ".Enabled = True"
		sReplace = cStr1 & ".UserInteractionEnabled = True"
		strSource = strSource.Replace(sFind,sReplace)
		sFind = cStr1 & ".Enabled = False"
		sReplace = cStr1 & ".UserInteractionEnabled = False"
		strSource = strSource.Replace(sFind,sReplace)
	Next	
	strSource = "'Put this code inside your Process_Globals" & CRLF & "Private pg As Page" & CRLF & "Private hd As HUD" & strSource
	txtTarget.Text = strSource
	Log(imgViews)
End Sub

Sub FixStartActivity(strLine As String) As String
	'StartActivity(frmDays)
	Dim strO As String
	' keep the original
	strO = strLine
	strLine = strLine.Trim
	strLine = strLine.ToLowerCase
	If jMash.StartsWith(strLine,"startactivity(") = True Then
		strLine = jMash.Replace(strLine,"startactivity","")
		strLine = jMash.Replace(strLine,"(","")
		strLine = jMash.Replace(strLine,")","")
		strLine = strLine & ".Show"
		Return strLine
	Else
		Return strO	
	End If
End Sub